--java读文件函数
function rawLoadFile(path)
	pcall(function() nativeLoadFile(path) end)
	return _G['_html_data']
end

function rawLoadResource(path)
    pcall(function() nativeLoadResource(path) end)
    return _G['_resource_data']
end

local template = require "template"
local json = require "json"

--获取表长度
function gettablen(tab)
  if not tab or type(tab)~="table" then return 0 end
  len = 0
  while true do
    index,value = next(tab,index)
    if index then
      len = len + 1
    else
      break
    end
  end
  return len
end

--返回table有效值
function tab(tab)
  if not tab or type(tab)~="table" then return {} end
  return tab
end

--可以循环table为空的table
function iter(t)
  return pairs(tab(t))
end
loop = iter

--转换为字符串
function tostr(str)
  if not str or type(str)~="string" or type(str)~="number" then return "" end
  str = tostring(str)
  if not str then return "" end
  return str
end

--转换为数字
function tonum(num)
  if not num or type(num)~="string" or type(num)~="number" then return 0 end
  num = tonumber(num)
  if not num then return 0 end
  return num
end

--截取两端空格
function trim (s)
  return (string.gsub(s, "^%s*(.-)%s*$", "%1"))
end

--高亮显示关键词
function hightlight(str, word)
  if not str or type(str)~="string" then return str end
  word = string.gsub(word, ".","%%%1")
  str = string.gsub(str, word, "<span class='hightlight'>%1</span>")
  return str
end

--url编码
function urldecode(s)
    s = string.gsub(s, '%%(%x%x)', function(h) return string.char(tonumber(h, 16)) end)
    return s
end

--url解码
function urlencode(s)
    s = string.gsub(s, "([^%w%.%- ])", function(c) return string.format("%%%02X", string.byte(c)) end)
    return string.gsub(s, " ", "+")
end

--string buffer 大字符串处理函数
--调用方法：
--local s = newStrBuf()
--s:add("add strings in here")
--print(s:get())
function newStrBuf(s)
  local strbuf = {}
  strbuf.buf = {}
  strbuf.new = function(self, s) self.buf={s or ""} return self end
  strbuf.get = function(self) return table.concat(self.buf) end
  strbuf.len = function(self) return string.len(self:get()) end
  strbuf.add = function(self, s)
    table.insert(self.buf, s)
    for i=table.getn(self.buf)-1, 1, -1 do
      if string.len(self.buf[i]) > string.len(self.buf[i+1]) then
        break
      end
      self.buf[i] = self.buf[i] .. table.remove(self.buf)
    end
  end
  return strbuf:new(s)
end

--print_r函数 用于调试
function pr(t, name, indent)
    local tableList = {}
    function table_r (t, name, indent, full)
        local id = not full and name or type(name)~="number" and tostring(name) or '['..name..']'
        local tag = indent .. id .. ' = '
        local out = {}  -- result
        if type(t) == "table" then
            if tableList[t] ~= nil then
                table.insert(out, tag .. '{} -- ' .. tableList[t] .. ' (self reference)')
            else
                tableList[t]= full and (full .. '.' .. id) or id
                if next(t) then -- Table not empty
                    table.insert(out, tag .. '{')
                    for key,value in pairs(t) do
                        table.insert(out,table_r(value,key,indent .. '|  ',tableList[t]))
                    end
                    table.insert(out,indent .. '}')
                else table.insert(out,tag .. '{}') end
            end
        else
            local val = type(t)~="number" and type(t)~="boolean" and '"'..tostring(t)..'"' or tostring(t)
            table.insert(out, tag .. val)
        end
        return table.concat(out, '\n')
    end
    return table_r(t,name or 'Value',indent or '')
end
function _print_r(t, name)
    println(pr(t,name))
end
function print_r(t, name)
    return pr(t,name)
end
function print_pre(t, name)
    return "<pre><xmp>"..pr(t,name).."</xmp></pre>"
end

--随机数相关函数 一般用于调试
function initrandom()
  if not _G['_is_randomseeded'] then
    math.randomseed(tostring(os.time()):reverse():sub(1, 6))
    _G['_is_randomseeded'] = true
  end
end
function getrandom(usesys, ...)
  initrandom()
  if usesys then return math.random(...) end
  if _test_ and type(_test_)=="number" and _test_>0 then
    return "?"..math.random(...)
  end
  return ""
end

-- 遍历数组  
function IsInTable(value, tbl)
for k,v in ipairs(tbl) do
   if v == value then
    return true;
   end
end
return false;
end

--local createIndex = template.render("html/index.html")
local funcTable = {}

--java调用主函数
function html4Android(word)
	local data = word:getJson()
  template.caching(false)
  template.use_global_include(true)
	local json_obj = json.decode(data)
	if json_obj._other and type(json_obj._other.is_in_scb)=="boolean" then
    if json_obj._other.is_in_scb then
        json_obj._other.is_in_scb = "1"
    else
        json_obj._other.is_in_scb = "0"
    end
  end
  if json_obj._other.textSize then
  json_obj._other.textSize = math.ceil(json_obj._other.textSize/1.5)
  end
	--local html = createIndex(json_obj)
    local templateName = json_obj._other.html;
	if funcTable[templateName] == nil then
	    funcTable[templateName] = template.render("html/"..templateName)
	end

	local html = funcTable[templateName](json_obj)

	word:setHtml(html)
	return word
end

function init()
local createIndex = template.render("html/index.html")
funcTable["index.html"] =createIndex
end

